datablock FxDTSBrickData(BrickStraightWireData : Brick1x1Data)
{
  uiName = "Straight Wire";
  category = "Power";
  subCategory = "Wires";
  brickFile = "./bricks/straight.blb";
	isPower = 1;
  isWire = 1;
  directions = "1 3";
};

datablock FxDTSBrickData(BrickTurnWireData : Brick1x1Data)
{
  uiName = "Turn Wire";
  category = "Power";
  subCategory = "Wires";
  brickFile = "./bricks/turn.blb";
	isPower = 1;
  isWire = 1;
  orientationFix = 2;
  directions = "0 1";
};

datablock FxDTSBrickData(BrickForkWireData : Brick1x1Data)
{
  uiName = "Fork Wire";
  category = "Power";
  subCategory = "Wires";
  brickFile = "./bricks/t.blb";
	isPower = 1;
  isWire = 1;
  orientationFix = 1;
  directions = "0 3 2";
};

datablock FxDTSBrickData(BrickCrossWireData : Brick1x1Data)
{
  uiName = "Cross Wire";
  category = "Power";
  subCategory = "Wires";
  brickFile = "./bricks/x.blb";
	isPower = 1;
  isWire = 1;
  directions = "0 1 2 3";
};

function FxDTSBrickData::onWirePlant(%this, %obj)
{
  WireGroup.add(%obj);
  %links = %obj.getPowerLinks();

  if (%links $= "")
    return;

  %count = getWordCount(%links);

  for (%i = 0; %i < %count; %i++)
  {
    %link = getWord(%links, %i);
    %link.setColorFX(3);
    %link.schedule(500, setColorFX, 0);
  }

  makePowernets();
}

package PowerBricksPackage
{
  function FxDTSBrickData::onPlant(%this, %obj)
  {
    Parent::onPlant(%this, %obj);

    if (%this.isPower)
    {
      if (%this.isWire)
        %this.onWirePlant(%obj);
    }
  }

  function FxDTSBrickData::onLoadPlant(%this, %obj)
  {
    Parent::onLoadPlant(%this, %obj);

    if (%this.isPower)
    {
      if (%this.isWire)
        %this.onWirePlant(%obj);
    }
  }

  function FxDTSBrick::onRemove(%this)
  {
    if (isObject(%this.powernet))
    {
      %this.powernet.removeWire(%this);
      %this.powernet = "";
    }

    schedule(0, 0, makePowernets);
    Parent::onRemove(%this);
  }

  function FxDTSBrick::onDeath(%this)
  {
    if (isObject(%this.powernet))
    {
      %this.powernet.removeWire(%this);
      %this.powernet = "";
    }

    schedule(0, 0, makePowernets);
    Parent::onDeath(%this);
  }
};

activatePackage("PowerBricksPackage");
