exec("./bricks.cs");
exec("./power.cs");

function FxDTSBrick::getRayPos(%this)
{
  %z = getWord(%this.getWorldBox(), 2);
  %z += 0.1;

  %pos = %this.getPosition();
  %pos = setWord(%pos, 2, %z);

  return %pos;
}

function FxDTSBrick::getRayVec(%this, %angle)
{
  %angle += %this.angleID;
  %angle += %this.getDataBlock().orientationFix;
  %angle %= 4;

  switch (%angle)
  {
    case 0: return "1 0 0";
    case 1: return "0 -1 0";
    case 2: return "-1 0 0";
    case 3: return "0 1 0";
  }

  return "0 0 0";
}

function FxDTSBrick::getPowerLinks(%this)
{
  %pos = %this.getRayPos();
  %dirs = %this.getWireDirs();
  %count = getFieldCount(%dirs);

  for (%i = 0; %i < %count; %i++)
  {
    %dir = getField(%dirs, %i);
    %path = vectorScale(%dir, 0.5);

    %ray = containerRayCast(
      %pos, vectorAdd(%pos, %path),
      $TypeMasks::FxBrickObjectType, %this
    );

    %col = getWord(%ray, 0);

    if (!%col || !%col.getDataBlock().isPower)
    {
      %links = appendWord(%links, 0);
      continue;
    }

    if (%col.isDead() || %col.isFakeDead())
    {
      %links = appendWord(%links, 0);
      continue;
    }

    %test = %col.getWireDirs();

    if (!hasField(%test, multiplyWords(%dir, -1)))
    {
      %links = appendWord(%links, 0);
      continue;
    }

    %links = appendWord(%links, %col);
  }

  return %links;
}

function FxDTSBrick::getWireDirs(%this)
{
  %name = %this.getDataBlock().getName();
  %angle = %this.angleID;
  %angle -= %this.getDataBlock().orientationFix;

  if (%angle < 0)
    %angle += 4;

  if (%name $= "BrickStraightWireData")
  {
    return %angle % 2 == 0 ? "0 1\t0 -1" : "1 0\t-1 0";
  }

  if (%name $= "BrickForkWireData")
  {
    switch (%angle)
    {
      case 0: return "1 0\t0 1\t0 -1";
      case 1: return "0 -1\t1 0\t-1 0";
      case 2: return "-1 0\t0 1\t0 -1";
      case 3: return "0 1\t1 0\t-1 0";
    }
  }

  if (%name $= "BrickTurnWireData")
  {
    switch (%angle)
    {
      case 0: return "1 0\t0 -1";
      case 1: return "-1 0\t0 -1";
      case 2: return "-1 0\t0 1";
      case 3: return "1 0\t0 1";
    }
  }

  return "1 0\t-1 0\t0 1\t0 -1";
}

function hasField(%fields, %field)
{
  %count = getFieldCount(%fields);

  for (%i = 0; %i < %count; %i++)
    if (strStr(%field, getField(%fields, %i)) == 0)
      return 1;

  return 0;
}

function appendField(%list, %field)
{
  if (%field $= "")
    return %list;

  if (%list $= "")
    return %field;

  return %list TAB %field;
}

function appendWord(%list, %word)
{
  if (%word $= "")
    return %list;

  if (%list $= "")
    return %word;

  return %list SPC %word;
}

function multiplyWords(%words, %scalar)
{
  %count = getWordCount(%words);

  for (%i = 0; %i < %count; %i++)
    %words = setWord(%words, %i, getWord(%words, %i) * %scalar);

  return %words;
}

if (!isObject(WireGroup))
  new SimSet(WireGroup);
